( 3iI2C.fs - 2021-06-03---Thu---14:24 )
( GForth file for communicating directly with OLED display's SSD1306 driver IC, allowing for bare metal development, with use of e.g. Adafruit's SSD1306 device driver software or their GFX graphics library. )

( 2021-06-08---Tue---13:13 - revisiting following completion of 3iI2C.avr )


: i2c-init ( -- ) \ setup Wire instance
    CALL_I2C_INIT xcall 
    $3C 31 setreg  \ store address
;

: i2c-setclock ( val/10k -- ) \ e.g. 10 means 100kHz bitrate
    xstore CALL_I2C_SETCLOCK xcall ;

: i2c-restoreclock ( val/10k -- ) \ e.g. 10 means 100kHz bitrate
    MSG-BUFFER [memstore] tx CALL_I2C_RESTORECLOCK xcall ;

: [oled-bytes]  ( b1 b2 b3 ... bn N -- )  \ sends N bytes in reverse order and puts N at the end (target TOS)
    >r r@ revstore r> xstore ;

: oled-cmd  [oled-bytes] CALL_I2C_CMDOLED xcall ;

: oled-data [oled-bytes] CALL_I2C_DATAOLED xcall ;

\ ===================================================

: oled-init1 ( -- )
    $AE $D5 $80 $A8  4 oled-cmd ;

: oled-post1 ( -- )
    63  1 oled-cmd ;
    
: oled-init2 ( -- )
    $D3 $0 $40 $0 or $8D  4 oled-cmd ;

: oled-post2 ( -- )
    14  1 oled-cmd ;

: oled-init3 ( -- )
    $20 $0  $A0 $1 or $C8  4 oled-cmd ;

: oled-init4 ( -- )
    $DA $12 $81 $CF   4 oled-cmd ;
    
: oled-init5 ( -- )
    $D9 $F1  2 oled-cmd ;

: oled-init6 ( -- )
    $DB $40 $A4 $A6 $2E $AF  6 oled-cmd ;

: oled-cursor ( -- )
   $22 0 $FF $21 0 127    6 oled-cmd ;

: oled-activate
   i2c-init
   10 i2c-setclock
   oled-init1 oled-post1
   oled-init2 oled-post2
   oled-init3
   oled-init4
   oled-init5
   oled-init6
   oled-cursor ;


: oled-rowchar ( asc -- ) 
   16 0 do dup loop drop   16 oled-data ;
   
: oled-clearrow  $0    oled-rowchar  ;
: oled-fillrow   $255  oled-rowchar  ;
   


\ need I2C communication primitives (see Wire.h/.cpp)
\ Excellent tutorial: https://mansfield-devine.com/speculatrix/2018/02/avr-basics-using-the-i2c-bus-2-transmitting/
\ primitive is Arduino's setClock() function which sets clock speed / crystal
\ safe default for I2C is 100 kHz (standard speed) or 400 kHz (fast).  Nano clock speed is 16MHz.
\ CPU frequency is scaled so it cannot generate all possible frequencies

\ : setclk
\    TWBR = ((F_CPU / frequency) - 16) / 2;  \ sets register  .e.g. 16000 / 100 ->72  - note this uses TWI (two-wire interface)

\ ==========================================

( Writing this by translating the driver software into Forth.  )
( There is so much to discard in C! C code feels like obfuscation-ware )

\ V1 - 2021-06-09---Wed---04:27  - WORKS! (with revised 3iForth.fs comms protocol